﻿
using System;

namespace SolidBlog.Tests
{
    public class OrderProcessorSeparate
    {
        private ISendMessage _messageSender;
        private IOrderValidator _orderValidator;
        private IRepository<Order> _orderRepository;

        public OrderProcessorSeparate(ISendMessage messageSender, IOrderValidator orderValidator, IRepository<Order> orderRepository)
        {
            _messageSender = messageSender;
            _orderValidator = orderValidator;
            _orderRepository = orderRepository;

        }

        public void Process(Order order)
        {
            if (_orderValidator.Validate(order))
            {
                if (_orderRepository.Save(order))
                {
                    _messageSender.SendConfirmationMessage(order);
                }
            }
        }
    }

    public interface IRepository<T>
    {
        bool Save<T>(T item);
    }

    public interface IOrderValidator
    {
        bool Validate(Order order);
    }

    public interface ISendMessage
    {
        bool SendConfirmationMessage(Order order);
    }
}
